<?php

/**
 * This file provides some testing configuration for the s3 module
 * files is based on http://undesigned.org.za/2007/10/22/amazon-s3-php-class
 */

/* **************************************************** */
/* Forms */
/* **************************************************** */


/**
 * build a form that will allow testing of Media Mover configurations
 * ftp settings
 * @return unknown_type
 */
function s3_api_test_form() {

  $form['display'] = array(
    '#type' => 'markup',
    '#value' => t('This test moves a file to Amazon S3 server, copies the file back, and then removes the file from S3<br/>'),
  );
//
//  $form['cid'] = array(
//    '#type' => 'select',
//    '#title' => t('Select a configuration to test'),
//    '#options' => $options,
//    '#description' => t('Choose a configuration to test sending and receiving a file from.'),
//  );
//
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Test'),
  );

  return $form;
}


/**
 * implement the testing functionality
 */
function s3_api_test_form_submit($form, &$form_state) {

  // -------------------------------------------------
  // POSSIBLE CONFIGURATION
  // get the file we will push to s3
  $test_upload = drupal_get_path('module', 's3_api'). '/test/test.png';
  // file name is the file name
  $test_upload_name = basename($test_upload);
  // path to the download file. drupal files should be writeable
  $test_download = file_directory_path() . '/s3_download_'. $test_upload_name;

//  // get the configuration data
//  $configuration = media_mover_api_get_configuration($form_state['values']['cid']);
//  // find the FTP settings
//  foreach (media_mover_api_verbs() as $verb) {
//    if ($configuration->{$verb}->module == 's3_api') {
//      $conf = $configuration->{$verb}->configuration;
//      break;
//    }
//  }


  /* **************************************************** */

  $s3_api_bucket = 's3_api_test_' . rand();

  // Check if our upload file exists
  if (!file_exists($test_upload) || !is_file($test_upload))
    exit("\nERROR: No such file: $test_upload\n\n");

  // are the keys good?
  if ($s3 = s3_api_class_check()) {
    // List your buckets:
    drupal_set_message("Listing all buckets for your S3 account:<br />". theme('item_list', $s3->listBuckets()));
    // does the requested bucket exist?
    if (s3_api_bucket_exists($s3_api_bucket, $s3)) {
      drupal_set_message(t('We found your bucket: !bucket on your account on the Amazon server', array('!bucket' => $s3_api_bucket)));
    }
    else {
//      $output[] = t('We did not find your bucket on your account on the Amazon server. Attempting to create it.');
      // Create a bucket with public read access
      if (! $s3->putBucket($s3_api_bucket, variable_get('s3_api_default_perm', ACL_PUBLIC_READ), false, false)) {
         drupal_set_message(t("Could not create your bucket: ". $s3_api_bucket .",  probably already exists"), 'error');
      }
      else {
        drupal_set_message(t("Created bucket ". $s3_api_bucket));
      }
    }

    // Get the contents of our bucket
    if ($contents = $s3->getBucket($s3_api_bucket)) {
      // get a usable list of files
      foreach($contents as $id => $file) {
        $list[] = $id;
      }
      drupal_set_message(t('S3::getBucket(): Files in bucket !bucket: !items', array(
        '!bucket' => $s3_api_bucket,
        '!items' => theme('item_list', $list)
      )));
    }

    // Put our file with the read access defined
    if ($s3->putObjectFile($test_upload, $s3_api_bucket, baseName($test_upload), variable_get('s3_api_default_perm', ACL_PUBLIC_READ))) {
      drupal_set_message(t('S3::putObjectFile(): File copied to !path', array(
        '!path' => $s3_api_bucket .'/'. baseName($test_upload)
      )));
    }
    else {
      drupal_set_message(t('S3::putObjectFile(): Failed to copy file\n'), 'error');
    }

    // Get object info
    $info = $s3->getObjectInfo($s3_api_bucket, baseName($test_upload));
    drupal_set_message(t('S3::getObjecInfo(): Info for !file: !items', array(
      '!file' => $s3_api_bucket .'/'. baseName($test_upload),
      '!items' => theme('item_list', $info)
    )));
    $file->filename = baseName($test_upload);
//echo ;
drupal_set_message('url is ' . s3_api_get_file($file, $s3_api_bucket));
    // Delete our file
    if ($s3->deleteObject($s3_api_bucket, baseName($test_upload))) {
      drupal_set_message(t('S3::deleteObject(): Deleted file'));
    }
    else {
      drupal_set_message(t('S3::deleteObject(): Failed to delete file'), 'error');
    }

    // Delete the bucket we created (a bucket has to be empty to be deleted)
    if ($s3->deleteBucket($s3_api_bucket)) {
      drupal_set_message(t('s3::deleteBucket(): Deleted bucket !bucket', array(
        '!bucket' => $s3_api_bucket
      )));
    }
    else {
      drupal_set_message(t('S3::deleteBucket(): Failed to delete bucket- it may not be empty'), 'error');
    }
  }
  return;
}